"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_2 = require("@storybook/react");
var Autocomplete_1 = require("./Autocomplete");
var pure_1 = require("../../utils/pure");
var Demo_1 = tslib_1.__importDefault(require("../demo/Demo"));
var Autocomplete_page_styl_1 = tslib_1.__importDefault(require("./Autocomplete.page.styl"));
var data = Array.from(new Array(20).keys()).map(function (v) { return "" + v; });
var filter = function (value) { return function (item, index) { return item.indexOf(value) !== -1; }; };
var theme = {
    Input: {
        container: Autocomplete_page_styl_1.default.autocomplete__input,
    },
    Popover: {
        container: Autocomplete_page_styl_1.default.autocomplete__popover,
    },
    MenuItem: {
        Highlight: {
            mark: Autocomplete_page_styl_1.default.highlight__mark,
        },
    },
};
var AutocompletePage = /** @class */ (function (_super) {
    tslib_1.__extends(AutocompletePage, _super);
    function AutocompletePage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: '',
        };
        _this.onValueChange = function (value) {
            _this.setState({
                value: value,
            });
        };
        return _this;
    }
    AutocompletePage.prototype.render = function () {
        return (react_1.default.createElement(Demo_1.default, null,
            react_1.default.createElement(Autocomplete_1.Autocomplete, { data: data, filter: filter, theme: theme, value: this.state.value, onValueChange: this.onValueChange })));
    };
    AutocompletePage = tslib_1.__decorate([
        pure_1.PURE
    ], AutocompletePage);
    return AutocompletePage;
}(react_1.default.Component));
react_2.storiesOf('Autocomplete', module).add('Default', function () {
    return (react_1.default.createElement(Demo_1.default, null,
        react_1.default.createElement(AutocompletePage, null)));
});
//# sourceMappingURL=Autocomplete.page.js.map