"use strict";
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var KeyCode;
(function (KeyCode) {
    KeyCode[KeyCode["Escape"] = 27] = "Escape";
    KeyCode[KeyCode["Left"] = 37] = "Left";
    KeyCode[KeyCode["Up"] = 38] = "Up";
    KeyCode[KeyCode["Down"] = 40] = "Down";
    KeyCode[KeyCode["Right"] = 39] = "Right";
    KeyCode[KeyCode["Delete"] = 46] = "Delete";
    KeyCode[KeyCode["Tab"] = 9] = "Tab";
    KeyCode[KeyCode["Enter"] = 13] = "Enter";
    KeyCode[KeyCode["Backspace"] = 8] = "Backspace";
    KeyCode[KeyCode["N0"] = 48] = "N0";
    KeyCode[KeyCode["N1"] = 49] = "N1";
    KeyCode[KeyCode["N2"] = 50] = "N2";
    KeyCode[KeyCode["N3"] = 51] = "N3";
    KeyCode[KeyCode["N4"] = 52] = "N4";
    KeyCode[KeyCode["N5"] = 53] = "N5";
    KeyCode[KeyCode["N6"] = 54] = "N6";
    KeyCode[KeyCode["N7"] = 55] = "N7";
    KeyCode[KeyCode["N8"] = 56] = "N8";
    KeyCode[KeyCode["N9"] = 57] = "N9";
    KeyCode[KeyCode["NUM0"] = 96] = "NUM0";
    KeyCode[KeyCode["NUM1"] = 97] = "NUM1";
    KeyCode[KeyCode["NUM2"] = 98] = "NUM2";
    KeyCode[KeyCode["NUM3"] = 99] = "NUM3";
    KeyCode[KeyCode["NUM4"] = 100] = "NUM4";
    KeyCode[KeyCode["NUM5"] = 101] = "NUM5";
    KeyCode[KeyCode["NUM6"] = 102] = "NUM6";
    KeyCode[KeyCode["NUM7"] = 103] = "NUM7";
    KeyCode[KeyCode["NUM8"] = 104] = "NUM8";
    KeyCode[KeyCode["NUM9"] = 105] = "NUM9";
    KeyCode[KeyCode["LETR_A"] = 65] = "LETR_A";
    KeyCode[KeyCode["LETR_P"] = 80] = "LETR_P";
})(KeyCode = exports.KeyCode || (exports.KeyCode = {}));
exports.KEY_CODE_NUM_MAP = (_a = {},
    _a[KeyCode.N0] = 0,
    _a[KeyCode.N1] = 1,
    _a[KeyCode.N2] = 2,
    _a[KeyCode.N3] = 3,
    _a[KeyCode.N4] = 4,
    _a[KeyCode.N5] = 5,
    _a[KeyCode.N6] = 6,
    _a[KeyCode.N7] = 7,
    _a[KeyCode.N8] = 8,
    _a[KeyCode.N9] = 9,
    _a[KeyCode.NUM0] = 0,
    _a[KeyCode.NUM1] = 1,
    _a[KeyCode.NUM2] = 2,
    _a[KeyCode.NUM3] = 3,
    _a[KeyCode.NUM4] = 4,
    _a[KeyCode.NUM5] = 5,
    _a[KeyCode.NUM6] = 6,
    _a[KeyCode.NUM7] = 7,
    _a[KeyCode.NUM8] = 8,
    _a[KeyCode.NUM9] = 9,
    _a);
exports.KEY_CODE_LETR_MAP = (_b = {},
    _b[KeyCode.LETR_A] = 'A',
    _b[KeyCode.LETR_P] = 'P',
    _b);
function stateful(valueName, handlerName, defaultValueName) {
    if (valueName === void 0) { valueName = 'value'; }
    if (handlerName === void 0) { handlerName = 'onValueChange'; }
    if (defaultValueName === void 0) { defaultValueName = 'defaultValue'; }
    return function decorate(Target) {
        var Stateful = /** @class */ (function (_super) {
            tslib_1.__extends(Stateful, _super);
            function Stateful() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.onValueChange = function (value) {
                    _this.setState({
                        value: value,
                    });
                    var onValueChange = _this.props[handlerName];
                    onValueChange && onValueChange(value);
                };
                return _this;
            }
            Stateful.prototype.componentWillMount = function () {
                this.setState({
                    value: this.props[defaultValueName],
                });
            };
            Stateful.prototype.render = function () {
                var _a;
                var props = Object.assign({}, this.props, (_a = {},
                    _a[valueName] = this.state.value,
                    _a[handlerName] = this.onValueChange,
                    _a));
                //tslint:disable-next-line no-any - fix for react typings
                return react_1.default.createElement(Target, props);
            };
            Stateful.displayName = "Stateful(" + (Target.displayName || Target.name || 'Component') + ")";
            return Stateful;
        }(react_1.default.Component));
        return Stateful;
    };
}
exports.stateful = stateful;
//tslint:enable max-line-length
//# sourceMappingURL=Control.js.map