"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var ExpandableHandler_1 = require("./ExpandableHandler");
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
var with_defaults_1 = require("../../utils/with-defaults");
exports.EXPANDABLE = Symbol('Expandable');
var RawExpandable = /** @class */ (function (_super) {
    tslib_1.__extends(RawExpandable, _super);
    function RawExpandable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onHandlerClick = function () {
            var _a = _this.props, onValueChange = _a.onValueChange, value = _a.value;
            onValueChange && onValueChange(!value);
        };
        return _this;
    }
    RawExpandable.prototype.render = function () {
        var _a;
        var _b = this.props, theme = _b.theme, Handler = _b.Handler, value = _b.value, children = _b.children;
        var className = classnames_1.default(theme.container, (_a = {},
            _a[theme.container_isExpanded] = value,
            _a));
        return (react_1.default.createElement("div", { className: className },
            react_1.default.createElement("div", { className: theme.handler, onClick: this.onHandlerClick },
                react_1.default.createElement(Handler, { isExpanded: value, theme: theme.Handler })),
            react_1.default.createElement("div", { className: theme.content }, children)));
    };
    RawExpandable = tslib_1.__decorate([
        pure_1.PURE
    ], RawExpandable);
    return RawExpandable;
}(react_1.default.Component));
exports.Expandable = withTheme_1.withTheme(exports.EXPANDABLE)(with_defaults_1.withDefaults({
    Handler: ExpandableHandler_1.ExpandableHandler,
})(RawExpandable));
//# sourceMappingURL=Expandable.js.map