import { TFullListItemGroupProps, TFullListItemProps, TFullListProps, TListItemGroupProps, TListItemProps, TListProps } from '../List/List';
import { ComponentClass, ComponentType, ReactElement, ReactNode, ReactText } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { ReactChildren } from '../../utils/typings';
export declare const MENU: symbol;
export declare type TMenuChildProps = {
    onSelect?: (value: ReactText) => void;
};
export declare type TFullMenuProps = TFullListProps & {
    List: ComponentType<TListProps>;
    onItemSelect?: (value: ReactText) => void;
    children: ReactChildren<ReactElement<TMenuChildProps>>;
};
export declare type TMenuProps = PartialKeys<TFullMenuProps, 'theme' | 'List'>;
export declare const Menu: ComponentClass<TMenuProps>;
export declare type TFullMenuItemProps = TFullListItemProps & {
    theme: {
        item_active?: string;
        item__content?: string;
    };
    ListItem: ComponentType<TListItemProps>;
    value: ReactText;
    isActive?: boolean;
    onSelect?: (value: ReactText) => void;
    text?: string;
    children?: ReactNode;
};
export declare type TMenuItemProps = PartialKeys<TFullMenuItemProps, 'theme' | 'ListItem'>;
export declare const MenuItem: ComponentClass<TMenuItemProps>;
export declare type TFullMenuItemGroupProps = TFullListItemGroupProps & {
    theme: {
        itemGroup__header__content?: string;
    };
    ListItemGroup: ComponentType<TListItemGroupProps>;
    List: ComponentType<TListProps>;
    onSelect?: (value: ReactText) => void;
    isCollapsed: boolean;
    header?: ReactNode;
};
export declare type TMenuItemGroupProps = PartialKeys<TFullMenuItemGroupProps, 'theme' | 'List' | 'ListItemGroup' | 'isCollapsed'>;
export declare const MenuItemGroup: ComponentClass<TMenuItemGroupProps>;
