"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var List_1 = require("../List/List");
var withTheme_1 = require("../../utils/withTheme");
var react_2 = require("react");
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var Pure_1 = require("../Pure/Pure");
var with_defaults_1 = require("../../utils/with-defaults");
exports.MENU = Symbol('Menu');
var RawMenu = /** @class */ (function (_super) {
    tslib_1.__extends(RawMenu, _super);
    function RawMenu() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawMenu.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, List = _a.List;
        return (react_1.default.createElement(List, tslib_1.__assign({}, this.props), react_1.default.Children.map(children, function (child) {
            if (!react_1.default.isValidElement(child)) {
                return child;
            }
            var props = {
                onSelect: _this.props.onItemSelect,
            };
            return react_1.default.cloneElement(child, props);
        })));
    };
    return RawMenu;
}(react_1.default.Component));
exports.Menu = withTheme_1.withTheme(exports.MENU)(with_defaults_1.withDefaults({ List: List_1.List })(RawMenu));
var RawMenuItem = /** @class */ (function (_super) {
    tslib_1.__extends(RawMenuItem, _super);
    function RawMenuItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function () {
            _this.props.onSelect && _this.props.onSelect(_this.props.value);
        };
        return _this;
    }
    RawMenuItem.prototype.render = function () {
        var _a = this.props, isActive = _a.isActive, ListItem = _a.ListItem;
        var theme = this.props.theme;
        if (isActive) {
            theme = tslib_1.__assign(tslib_1.__assign({}, theme), { item: classnames_1.default(theme.item, theme.item_active) });
        }
        return (react_1.default.createElement(ListItem, tslib_1.__assign({ onClick: this.onClick }, this.props, { theme: theme }),
            react_1.default.createElement("div", { className: theme.item__content }, this.props.children)));
    };
    RawMenuItem = tslib_1.__decorate([
        pure_1.PURE
    ], RawMenuItem);
    return RawMenuItem;
}(react_2.Component));
exports.MenuItem = withTheme_1.withTheme(exports.MENU)(with_defaults_1.withDefaults({ ListItem: List_1.ListItem })(RawMenuItem));
var RawMenuItemGroup = /** @class */ (function (_super) {
    tslib_1.__extends(RawMenuItemGroup, _super);
    function RawMenuItemGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isCollapsed: true,
        };
        _this.onClick = function () {
            _this.setState({
                isCollapsed: !_this.state.isCollapsed,
            });
        };
        return _this;
    }
    RawMenuItemGroup.prototype.componentWillMount = function () {
        this.setState({
            isCollapsed: this.props.isCollapsed,
        });
    };
    RawMenuItemGroup.prototype.componentWillReceiveProps = function (props) {
        this.setState({
            isCollapsed: props.isCollapsed,
        });
    };
    RawMenuItemGroup.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, theme = _a.theme, ListItemGroup = _a.ListItemGroup;
        var header;
        if (this.props.header) {
            header = react_1.default.createElement("div", { className: theme.itemGroup__header__content }, this.props.header);
        }
        return (react_1.default.createElement(ListItemGroup, tslib_1.__assign({ onClick: this.onClick }, this.props, { header: header, isCollapsed: this.state.isCollapsed }),
            react_1.default.createElement(Pure_1.Pure, { check: children }, function () {
                return react_1.default.isValidElement(children) &&
                    react_1.default.cloneElement(react_1.default.Children.only(children), {
                        onItemSelect: _this.props.onSelect,
                    });
            })));
    };
    RawMenuItemGroup = tslib_1.__decorate([
        pure_1.PURE
    ], RawMenuItemGroup);
    return RawMenuItemGroup;
}(react_1.default.Component));
exports.MenuItemGroup = withTheme_1.withTheme(exports.MENU)(with_defaults_1.withDefaults({
    ListItemGroup: List_1.ListItemGroup,
    List: exports.Menu,
    isCollapsed: true,
})(RawMenuItemGroup));
//# sourceMappingURL=Menu.js.map