"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var react_2 = require("@storybook/react");
var Demo_1 = require("../demo/Demo");
var NumericStepper_1 = require("./NumericStepper");
var add_icon_1 = require("../../icons/add-icon");
var decrease_icon_1 = require("../../icons/decrease-icon");
var small_cross_icon_1 = require("../../icons/small-cross-icon");
var dollarFormatter = function (value) { return "$" + value; };
var dollarParser = function (input) {
    var newValue = parseInt(input.replace(/\D/g, ''), 10);
    return isNaN(newValue) ? 0 : newValue;
};
var Control_1 = require("../Control/Control");
var StatefulStepper = Control_1.stateful()(NumericStepper_1.NumericStepper);
react_2.storiesOf('NumericStepper', module)
    .add('default', function () { return (react_1.default.createElement(Demo_1.Demo, null,
    react_1.default.createElement(StatefulStepper, { decrementIcon: react_1.default.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: react_1.default.createElement(add_icon_1.AddIcon, null), min: -10, max: 10, step: 1, clearIcon: react_1.default.createElement(small_cross_icon_1.SmallCrossIcon, null), defaultValue: 5 }))); })
    .add('disabled', function () { return (react_1.default.createElement(Demo_1.Demo, null,
    react_1.default.createElement(StatefulStepper, { decrementIcon: react_1.default.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: react_1.default.createElement(add_icon_1.AddIcon, null), isDisabled: true, min: 0, step: 1, clearIcon: react_1.default.createElement(small_cross_icon_1.SmallCrossIcon, null), defaultValue: 5 }))); })
    .add('with custom formatter', function () { return (react_1.default.createElement(Demo_1.Demo, null,
    react_1.default.createElement(StatefulStepper, { decrementIcon: react_1.default.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: react_1.default.createElement(add_icon_1.AddIcon, null), min: 0, step: 1, parser: dollarParser, formatter: dollarFormatter, clearIcon: react_1.default.createElement(small_cross_icon_1.SmallCrossIcon, null), defaultValue: 5 }))); });
//# sourceMappingURL=NumericStepper.page.js.map