import { ComponentClass, MouseEventHandler, ReactNode } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { ReactRef } from '../../utils/typings';
import { PopoverPlacement, PopoverAlign } from './Popover.model';
export { PopoverPlacement, PopoverAlign } from './Popover.model';
export declare const POPOVER: symbol;
export declare type TFullPopoverProps = {
    children: ReactNode;
    isOpened?: boolean;
    closeOnClickAway?: boolean;
    disableCloseOnScroll?: boolean;
    anchor?: ReactRef;
    onMouseDown?: MouseEventHandler<Element>;
    placement: PopoverPlacement;
    align: PopoverAlign;
    container?: Element;
    onRequestClose?: () => any;
    hasArrow?: boolean;
    theme: {
        container?: string;
        container_hasArrow?: string;
        container_placementTop?: string;
        container_placementBottom?: string;
        container_placementLeft?: string;
        container_placementRight?: string;
        content?: string;
        arrow?: string;
    };
    style?: object;
};
export declare type TPopoverProps = PartialKeys<TFullPopoverProps, 'theme' | 'align' | 'placement'>;
export declare const Popover: ComponentClass<TPopoverProps>;
