export declare enum PopoverPlacement {
    Top = "Top",
    Bottom = "Bottom",
    Left = "Left",
    Right = "Right"
}
export declare enum PopoverAlign {
    Top = "Top",
    Bottom = "Bottom",
    Left = "Left",
    Right = "Right",
    Middle = "Middle",
    Center = "Center"
}
export declare type TVerticalPosition = {
    top: number;
    placement: PopoverPlacement;
    align: PopoverAlign;
};
export declare type TVerticalMoveProps = {
    placement: PopoverPlacement;
    align: PopoverAlign;
    anchorTop: number;
    anchorBottom: number;
    popoverHeight: number;
    parentHeight: number;
    previousPlacement?: PopoverPlacement;
    checkBounds?: boolean;
};
export declare function movePopoverVertically({ placement, align, anchorTop, anchorBottom, popoverHeight, parentHeight, previousPlacement, checkBounds, }: TVerticalMoveProps): TVerticalPosition | undefined;
export declare type THorizontalMoveProps = {
    placement: PopoverPlacement;
    align: PopoverAlign;
    anchorLeft: number;
    anchorRight: number;
    popoverWidth: number;
    parentWidth: number;
    checkBounds?: Boolean;
    previousPlacement?: PopoverPlacement;
};
export declare type THorizontalPosition = {
    left: number;
    placement: PopoverPlacement;
    align: PopoverAlign;
};
export declare function movePopoverHorizontally({ placement, align, anchorLeft, anchorRight, popoverWidth, parentWidth, checkBounds, previousPlacement, }: THorizontalMoveProps): THorizontalPosition | undefined;
export declare function getPlacementModifier(placement: PopoverPlacement): string;
