"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Popup_1 = require("./Popup");
var react_2 = require("@storybook/react");
var pure_1 = require("../../utils/pure");
var Demo_1 = tslib_1.__importDefault(require("../demo/Demo"));
var Button_1 = require("../Button/Button");
var Selectbox_1 = require("../Selectbox/Selectbox");
var Control_1 = require("../Control/Control");
var Menu_1 = require("../Menu/Menu");
var Popup_page_styl_1 = tslib_1.__importDefault(require("./Popup.page.styl"));
var theme = {
    container: Popup_page_styl_1.default.container,
};
var popupTheme = {
    container: Popup_page_styl_1.default.popup,
};
var header = react_1.default.createElement("div", null, "HEADER");
var footer = react_1.default.createElement("div", null, "FOOTER");
var Stateful = Control_1.stateful()(Selectbox_1.Selectbox);
var StatefulOpened = Control_1.stateful('isOpened', 'onToggle')(Stateful);
var PopupPage = /** @class */ (function (_super) {
    tslib_1.__extends(PopupPage, _super);
    function PopupPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpened: false,
            isModal: false,
            shouldCloseOnClickAway: false,
        };
        _this.onToggleClick = function () {
            _this.setState({
                isOpened: !_this.state.isOpened,
            });
        };
        _this.onIsModalChange = function () {
            _this.setState({
                isModal: !_this.state.isModal,
            });
        };
        _this.onCloseOnClickAwayChange = function () {
            _this.setState({
                shouldCloseOnClickAway: !_this.state.shouldCloseOnClickAway,
            });
        };
        _this.onPopupRequestClose = function () {
            _this.setState({
                isOpened: false,
            });
        };
        return _this;
    }
    PopupPage.prototype.componentDidMount = function () {
        var html = document.querySelector('html');
        if (html) {
            html.classList.add(Popup_page_styl_1.default.html);
        }
    };
    PopupPage.prototype.componentWillUnmount = function () {
        var html = document.querySelector('html');
        if (html) {
            html.classList.remove(Popup_page_styl_1.default.html);
        }
    };
    PopupPage.prototype.render = function () {
        var _a = this.state, isOpened = _a.isOpened, isModal = _a.isModal, shouldCloseOnClickAway = _a.shouldCloseOnClickAway;
        return (react_1.default.createElement(Demo_1.default, { theme: theme },
            react_1.default.createElement("label", { className: Popup_page_styl_1.default.label },
                "Modal ",
                react_1.default.createElement("input", { type: "checkbox", value: isModal.toString(), onChange: this.onIsModalChange })),
            react_1.default.createElement("label", { className: Popup_page_styl_1.default.label },
                "Close on clickaway",
                ' ',
                react_1.default.createElement("input", { type: "checkbox", value: shouldCloseOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange })),
            !isModal && shouldCloseOnClickAway && (react_1.default.createElement("label", { className: Popup_page_styl_1.default.label }, "When isModal === false && shouldCloseOnClickAway === true popup will close on click inside inner selectbox, because there is no backdrop and selectbox is rendered to body")),
            react_1.default.createElement(Button_1.Button, { isPrimary: true, onClick: this.onToggleClick },
                isOpened ? 'Close' : 'Open',
                react_1.default.createElement(Popup_1.Popup, { theme: popupTheme, header: header, footer: footer, isModal: isModal, shouldCloseOnClickAway: shouldCloseOnClickAway, onRequestClose: this.onPopupRequestClose, isOpened: isOpened },
                    react_1.default.createElement("div", null, "popup content"),
                    react_1.default.createElement(StatefulOpened, { defaultValue: undefined, placeholder: "Choose your hero" },
                        react_1.default.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                        react_1.default.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash"))))));
    };
    PopupPage = tslib_1.__decorate([
        pure_1.PURE
    ], PopupPage);
    return PopupPage;
}(react_1.default.Component));
react_2.storiesOf('Popup', module).add('Default', function () { return react_1.default.createElement(PopupPage, null); });
//# sourceMappingURL=Popup.page.js.map