"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var EventListener_1 = require("../EventListener/EventListener");
var Bar = /** @class */ (function (_super) {
    tslib_1.__extends(Bar, _super);
    function Bar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isDragging: false,
        };
        _this.onBarClick = function (event) {
            event.stopPropagation();
        };
        _this.onDocumentSelectStart = function (event) {
            event.preventDefault();
            event.stopPropagation();
            return false;
        };
        _this.onDocumentMouseMove = function (event) {
            var onBarDrag = _this.props.onBarDrag;
            onBarDrag && onBarDrag(event);
        };
        _this.onDragEnd = function (event) {
            _this._stopDrag(event);
        };
        _this.onDocumentMouseUp = function (event) {
            _this._stopDrag(event);
        };
        _this._stopDrag = function (event) {
            var onBarDrag = _this.props.onBarDrag;
            _this.setState({
                isDragging: false,
            });
            onBarDrag && onBarDrag(event);
        };
        _this.onBarMouseDown = function (event) {
            var onBarDragStart = _this.props.onBarDragStart;
            onBarDragStart && onBarDragStart(event);
            _this.setState({
                isDragging: true,
            });
        };
        return _this;
    }
    Bar.prototype.render = function () {
        var isDragging = this.state.isDragging;
        var eventListenerProps = {
            target: 'window',
            capture: true,
        };
        if (isDragging) {
            eventListenerProps = tslib_1.__assign(tslib_1.__assign({}, eventListenerProps), { onMouseUp: this.onDocumentMouseUp, onMouseMove: this.onDocumentMouseMove, onSelectStart: this.onDocumentSelectStart, onDragEnd: this.onDragEnd });
        }
        var barProps = {
            onMouseDown: this.onBarMouseDown,
            onClick: this.onBarClick,
            className: this.props.theme.container,
        };
        return (react_1.default.createElement(EventListener_1.EventListener, tslib_1.__assign({}, eventListenerProps),
            react_1.default.createElement("div", tslib_1.__assign({}, barProps))));
    };
    Bar = tslib_1.__decorate([
        pure_1.PURE
    ], Bar);
    return Bar;
}(react_1.default.Component));
exports.Bar = Bar;
//# sourceMappingURL=Bar.js.map