import React from 'react';
export declare const SCROLLBAR: symbol;
export declare enum SCROLLBAR_TYPE {
    HORIZONTAL = "HORIZONTAL",
    VERTICAL = "VERTICAL"
}
export declare type TScrollbarProps = {
    container: HTMLDivElement;
    theme: {
        container?: string;
        containerIsVisible?: string;
        track?: string;
        bar?: string;
    };
};
export declare type TScrollbarState = {
    isVisible: boolean;
};
export declare class Scrollbar<T> extends React.Component<TScrollbarProps & T, TScrollbarState> {
    _scrollbar: HTMLDivElement | null;
    _container: HTMLDivElement | null;
    _track: HTMLDivElement | null;
    _bar: HTMLDivElement;
    static contextTypes: any;
    state: {
        isVisible: boolean;
    };
    constructor(props: TScrollbarProps & T, context: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    _updateBar(): void;
    _update(): void;
    /**
     * @param {Event} event
     * @private
     */
    _onContainerScroll: (event: any) => void;
    onResize: () => void;
    /**
     * @abstract
     * @param {WheelEvent} event
     * @protected
     */
    onTrackMouseWheel: (event: React.WheelEvent<HTMLDivElement>) => void;
    /**
     * @abstract
     * @param {MouseEvent} event
     * @protected
     */
    onTrackClick: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @abstract
     * @param {MouseEvent} event
     * @protected
     */
    onBarDragStart: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @abstract
     * @param {MouseEvent} event
     * @protected
     */
    onBarDrag: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
