"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var pure_1 = require("../../utils/pure");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var withTheme_1 = require("../../utils/withTheme");
exports.TABLE = Symbol('Table');
var RawTable = /** @class */ (function (_super) {
    tslib_1.__extends(RawTable, _super);
    function RawTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawTable.prototype.render = function () {
        var _a = this.props, theme = _a.theme, children = _a.children;
        return react_1.default.createElement("table", { className: theme.container }, children);
    };
    RawTable = tslib_1.__decorate([
        pure_1.PURE
    ], RawTable);
    return RawTable;
}(react_1.default.Component));
exports.default = RawTable;
var RawTableHead = /** @class */ (function (_super) {
    tslib_1.__extends(RawTableHead, _super);
    function RawTableHead() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawTableHead.prototype.render = function () {
        var _a = this.props, children = _a.children, theme = _a.theme;
        return (react_1.default.createElement("thead", { className: theme.head }, react_1.default.Children.map(children, function (child) {
            return react_1.default.isValidElement(child) &&
                react_1.default.cloneElement(child, {
                    isInHead: true,
                });
        })));
    };
    RawTableHead = tslib_1.__decorate([
        pure_1.PURE
    ], RawTableHead);
    return RawTableHead;
}(react_1.default.Component));
exports.RawTableHead = RawTableHead;
var RawTableBody = /** @class */ (function (_super) {
    tslib_1.__extends(RawTableBody, _super);
    function RawTableBody() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawTableBody.prototype.render = function () {
        var _a = this.props, children = _a.children, theme = _a.theme;
        return react_1.default.createElement("tbody", { className: theme.body }, children);
    };
    RawTableBody = tslib_1.__decorate([
        pure_1.PURE
    ], RawTableBody);
    return RawTableBody;
}(react_1.default.Component));
var RawTableRow = /** @class */ (function (_super) {
    tslib_1.__extends(RawTableRow, _super);
    function RawTableRow() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawTableRow.prototype.render = function () {
        var _a = this.props, children = _a.children, theme = _a.theme, onClick = _a.onClick, onMouseOver = _a.onMouseOver, onMouseOut = _a.onMouseOut, isInHead = _a.isInHead;
        return (react_1.default.createElement("tr", { className: theme.row, onClick: onClick, onMouseOver: onMouseOver, onMouseOut: onMouseOut },
            !isInHead && children,
            isInHead &&
                react_1.default.Children.map(children, function (child) {
                    return react_1.default.isValidElement(child) &&
                        react_1.default.cloneElement(child, tslib_1.__assign(tslib_1.__assign({}, child.props), { isInHead: isInHead }));
                })));
    };
    RawTableRow = tslib_1.__decorate([
        pure_1.PURE
    ], RawTableRow);
    return RawTableRow;
}(react_1.default.Component));
var RawTableCell = /** @class */ (function (_super) {
    tslib_1.__extends(RawTableCell, _super);
    function RawTableCell() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawTableCell.prototype.render = function () {
        var _a;
        var _b = this.props, children = _b.children, theme = _b.theme, style = _b.style, colSpan = _b.colSpan, rowSpan = _b.rowSpan, isInHead = _b.isInHead;
        var className = classnames_1.default(theme.cell, (_a = {},
            _a[theme.cell_isInHead] = isInHead,
            _a));
        //noinspection JSUnusedLocalSymbols
        var Tag = isInHead ? 'th' : 'td';
        return (react_1.default.createElement(Tag, { className: className, style: style, colSpan: colSpan, rowSpan: rowSpan }, children));
    };
    RawTableCell = tslib_1.__decorate([
        pure_1.PURE
    ], RawTableCell);
    return RawTableCell;
}(react_1.default.Component));
exports.Table = withTheme_1.withTheme(exports.TABLE)(RawTable);
exports.TableBody = withTheme_1.withTheme(exports.TABLE)(RawTableBody);
exports.TableHead = withTheme_1.withTheme(exports.TABLE)(RawTableHead);
exports.TableRow = withTheme_1.withTheme(exports.TABLE)(RawTableRow);
exports.TableCell = withTheme_1.withTheme(exports.TABLE)(RawTableCell);
//# sourceMappingURL=Table.js.map