import React from 'react';
import { TControlProps } from '../Control/Control';
import { ChangeEventHandler, ComponentClass, FocusEventHandler, KeyboardEventHandler, MouseEventHandler, WheelEventHandler } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { ReactRef } from '../../utils/typings';
export declare const INPUT: symbol;
export declare type TFullInputProps = TControlProps<string | undefined> & {
    min?: any;
    max?: any;
    isDisabled?: boolean;
    isReadOnly?: boolean;
    tabIndex?: number;
    type?: string;
    placeholder?: string;
    pattern?: string;
    name?: string;
    id?: string;
    error?: React.ReactNode;
    innerRef?: (instance: ReactRef) => void;
    onChange?: ChangeEventHandler<HTMLInputElement>;
    onFocus?: FocusEventHandler<HTMLElement>;
    onBlur?: FocusEventHandler<HTMLElement>;
    onClick?: MouseEventHandler<HTMLElement>;
    onMouseDown?: MouseEventHandler<HTMLElement>;
    onMouseUp?: MouseEventHandler<HTMLElement>;
    onMouseEnter?: MouseEventHandler<HTMLElement>;
    onMouseLeave?: MouseEventHandler<HTMLElement>;
    onKeyPress?: KeyboardEventHandler<HTMLElement | HTMLInputElement>;
    onKeyDown?: KeyboardEventHandler<HTMLElement | HTMLInputElement>;
    onKeyUp?: KeyboardEventHandler<HTMLElement | HTMLInputElement>;
    onWheel?: WheelEventHandler<HTMLElement>;
    theme: {
        container?: string;
        container_isFocused?: string;
        container_hasError?: string;
        container_isDisabled?: string;
        container_isReadOnly?: string;
        input?: string;
    };
};
export declare type TInputProps = PartialKeys<TFullInputProps, 'theme'>;
export declare const Input: ComponentClass<TInputProps>;
