"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_dnd_1 = require("react-dnd");
var react_dnd_proxy_1 = require("./react-dnd-proxy");
exports.DNDTypes = {
    ITEM: 'item',
};
var CustomBackend = /** @class */ (function (_super) {
    tslib_1.__extends(CustomBackend, _super);
    function CustomBackend() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomBackend.prototype.handleTopDragOver = function (e) {
        var item = this.monitor.getItem();
        var fits;
        switch (item.type) {
            case exports.DNDTypes.ITEM:
                fits = true;
                break;
            // the default state is for Layout drag
            default:
                if (this.dragOverTargetIds.length === 1) {
                    var canDrop = this.monitor.canDropOnTarget(this.dragOverTargetIds[0]);
                    if (canDrop) {
                        var isEmptyRoot = canDrop.isEmptyRoot, placement = canDrop.placement;
                        //noinspection RedundantIfStatementJS
                        if ((isEmptyRoot && !placement.fits && typeof placement.side === 'undefined') ||
                            (!isEmptyRoot && !placement.fits)) {
                            fits = false;
                        }
                        else {
                            fits = true;
                        }
                    }
                }
        }
        var dataTransfer = e.dataTransfer;
        if (dataTransfer === null) {
            return;
        }
        var originalEffect = dataTransfer.dropEffect;
        _super.prototype.handleTopDragOver.call(this, e);
        if (typeof fits === 'undefined') {
            dataTransfer.dropEffect = originalEffect;
        }
        else if (fits === false) {
            dataTransfer.dropEffect = 'none';
        }
        else if (fits === true) {
            dataTransfer.dropEffect = 'copy';
        }
    };
    return CustomBackend;
}(react_dnd_proxy_1.HTML5Backend));
//eslint-disable-next-line
exports.DNDContext = react_dnd_1.DragDropContext(function (manager) { return new CustomBackend(manager); });
//# sourceMappingURL=dnd-context.js.map