export declare const LAYOUT: symbol;
export declare type LAYOUT_THEME = {
    container?: string;
    container_horizontal?: string;
    container_vertical?: string;
    item?: string;
    item_nested?: string;
    item_horizontal?: string;
    item_vertical?: string;
    placeholder?: string;
    placeholder_maximized?: string;
    placeholder_fits?: string;
    placeholder_bottom?: string;
    placeholder_top?: string;
    placeholder_left?: string;
    placeholder_right?: string;
    placeholder_full?: string;
    resizeHandler?: string;
    resizeHandler_disabled?: string;
    fixedContainer?: string;
    Scrollable?: {};
};
export declare enum ItemSide {
    Top = "Top",
    Bottom = "Bottom",
    Left = "Left",
    Right = "Right"
}
export declare enum E_LAYOUT {
    ITEM_DROP = 0
}
export declare enum LayoutOrientation {
    Horizontal = 0,
    Vertical = 1
}
declare type BASE_ITEM_SHAPE = {
    id: string;
    size?: number;
    parent_id?: string;
};
export declare type ITEM_SHAPE = BASE_ITEM_SHAPE & {
    props: object;
};
export declare type LAYOUT_SHAPE = BASE_ITEM_SHAPE & {
    items: Array<object | ITEM_SHAPE>;
    item_ids: Array<string>;
    orientation: LayoutOrientation;
};
export declare type LAYOUT_VALUE_SHAPE = {
    root_id: string;
    items: Array<ITEM_SHAPE | LAYOUT_SHAPE>;
};
export declare type LAYOUT_SIZE_MAP_TYPE = {
    [s: string]: number;
};
export declare enum ResizeHandlerSide {
    Before = 0,
    After = 1,
    Both = 2
}
export declare const NATIVE_DRAG_DATA_KEY = "__NATIVE_DRAG_DATA_KEY__";
export declare const SESSION_ID_KEY = "__SESSION_ID_KEY__";
export declare enum LayoutModelItemType {
    Plain = 0,
    Layout = 1
}
export declare type TLayoutModelBase = {
    readonly id: string;
    readonly parent_id: string;
    readonly size: number;
};
export declare type TMinimumLayoutModelItemProps = {
    readonly minWidth?: number;
    readonly minHeight?: number;
};
export declare type TLayoutModelItem<P extends TMinimumLayoutModelItemProps> = TLayoutModelBase & {
    readonly type: LayoutModelItemType.Plain;
    readonly props?: P;
};
export declare type TLayoutModelLayout = TLayoutModelBase & {
    readonly type: LayoutModelItemType.Layout;
    readonly item_ids: Array<string>;
    readonly orientation: LayoutOrientation;
};
export declare type TLayoutItem<P extends TMinimumLayoutModelItemProps> = TLayoutModelItem<P> | TLayoutModelLayout;
export declare type TLayoutStructure<P extends TMinimumLayoutModelItemProps> = {
    readonly root_id: string;
    readonly items: Record<string, TLayoutItem<P>>;
};
export declare type TDenormalizedLayout<P extends TMinimumLayoutModelItemProps> = {
    readonly id: string;
    readonly size?: number;
    readonly orientation?: LayoutOrientation;
    readonly props?: P;
    readonly items?: Array<TDenormalizedLayout<P>>;
};
export {};
