import { HKT, URIS, Kind, Kind2, URIS2 } from 'fp-ts/lib/HKT';
import { MonadObservable, MonadObservable1, MonadObservable2 } from '@devexperts/utils/dist/typeclasses/monad-observable/monad-observable';
import { ComponentClass, ComponentType } from 'react';
import { Alternative2, Alternative1, Alternative } from 'fp-ts/lib/Alternative';
export declare type Observify<M, P extends object> = {
    readonly [K in keyof P]: HKT<M, P[K]>;
};
export declare type Observify1<M extends URIS, P extends object> = {
    readonly [K in keyof P]: Kind<M, P[K]>;
};
export declare type Observify2<M extends URIS2, P extends object, E> = {
    readonly [K in keyof P]: Kind2<M, E, P[K]>;
};
export interface WithObservableSelectorResult<M, P extends object, D extends Partial<P>> {
    props?: Partial<Observify<M, P>>;
    defaultProps?: D;
    effects$?: HKT<M, unknown>;
}
export interface WithObservableSelectorResult1<M extends URIS, P extends object, D extends Partial<P>> {
    props?: Partial<Observify1<M, P>>;
    defaultProps?: D;
    effects$?: Kind<M, unknown>;
}
export interface WithObservableSelectorResult2<M extends URIS2, P extends object, D extends Partial<P>, E> {
    props?: Partial<Observify2<M, P, E>>;
    defaultProps?: D;
    effects$?: Kind2<M, E, unknown>;
}
export interface WithObservable<M> {
    <P extends object>(Target: ComponentType<P>): <D extends Partial<P>>(selector: (props$: HKT<M, Readonly<P>>) => WithObservableSelectorResult<M, P, D>) => ComponentClass<Omit<P, keyof D> & Partial<D>>;
}
export interface WithObservable1<M extends URIS> {
    <P extends object>(Target: ComponentType<P>): <D extends Partial<P>>(selector: (props$: Kind<M, Readonly<P>>) => WithObservableSelectorResult1<M, P, D>) => ComponentClass<Omit<P, keyof D> & Partial<D>>;
}
export interface WithObservable2<M extends URIS2> {
    <P extends object>(Target: ComponentType<P>): <D extends Partial<P>>(selector: <E>(props$: Kind2<M, E, Readonly<P>>) => WithObservableSelectorResult2<M, P, D, E>) => ComponentClass<Omit<P, keyof D> & Partial<D>>;
}
export declare function withObservable<M extends URIS2>(M: MonadObservable2<M> & Alternative2<M>): WithObservable2<M>;
export declare function withObservable<M extends URIS>(M: MonadObservable1<M> & Alternative1<M>): WithObservable1<M>;
export declare function withObservable<M>(M: MonadObservable<M> & Alternative<M>): WithObservable<M>;
